CREATE TABLE masterindex (
	"id" integer unique,
	"directory" varchar(256) PRIMARY KEY,
	"table_name" varchar(64),
	"master" varchar(64),
	"owner_name" varchar(64),
	"permissions" char(3),
	"acls" varchar(2048)
);

INSERT INTO masterindex ("id", "directory", "table_name", "master", "owner_name", "permissions", "acls")
	         VALUES (1, '/', 'x', '', 'root', 'rwx', '|system:anyuser rx|');

CREATE TABLE groups ("name" varchar(64) PRIMARY KEY, "owner" varchar(64), "members" varchar(1024));
CREATE TABLE users ("name" varchar(129) PRIMARY KEY, "password" varchar(64));
CREATE TABLE certificates ("subject" varchar(256), "name" varchar(64) REFERENCES users ON DELETE CASCADE, PRIMARY KEY ("subject", "name"));
CREATE TABLE voms_user ("subject" varchar(256), "name" varchar(64), PRIMARY KEY ("subject"));
CREATE TABLE voms_group ("subject" varchar(256), "name" varchar(64), PRIMARY KEY ("subject"));
