/* Table for holding system information */
CREATE TABLE amga (
	`amga_version` varchar(8),
        `amga_node_id` varchar(64)
) TYPE = InnoDB;
INSERT INTO amga (`amga_version`) VALUES ('1.2');


ALTER TABLE masterindex ADD COLUMN `rep_groups` text(2048);
ALTER TABLE masterindex ADD COLUMN `rep_xid` BIGINT;
UPDATE masterindex SET master = '';

/* Replication: tables used as a master */
CREATE TABLE logs (
	`log_xid` BIGINT AUTO_INCREMENT,
	`log_directory` TEXT(256),
	`log_user` VARCHAR(64),
	`log_cwd` TEXT(256),
	`log_permissions` CHAR(3),
        `log_group_rights` CHAR(3),
        `log_command` TEXT,
	PRIMARY KEY (`log_xid`, `log_directory`(256))
) TYPE = InnoDB;

CREATE TABLE subscribers (
	`sub_id` VARCHAR(64),
	`sub_directory` TEXT(256),
	`sub_inherit` SMALLINT NOT NULL,
	`sub_lease_duration` TIMESTAMP,
	`sub_cur_xid` BIGINT,
	PRIMARY KEY (`sub_id`, `sub_directory`(256))
) TYPE = InnoDB;

/* Replication: tables used as a slave */
CREATE TABLE mounts (
        `mnt_master` VARCHAR(64) NOT NULL,
        `mnt_directory` TEXT(256),
        `mnt_state` VARCHAR(16),
        `mnt_last_xid` bigint,
        PRIMARY KEY(`mnt_directory`(256))
) TYPE = InnoDB;
