/* Table for holding system information */
CREATE TABLE amga (
	"amga_version" varchar(8),
        "amga_node_id" varchar(64)
);
INSERT INTO amga ("amga_version") VALUES ('1.2');

ALTER TABLE masterindex ADD COLUMN "rep_groups" varchar(2048);
ALTER TABLE masterindex ADD COLUMN "rep_xid" bigint;
UPDATE masterindex SET master = '';

/* Replication: tables used as a master */
CREATE TABLE logs (
	"log_xid" SERIAL,
	"log_directory" varchar(256),
	"log_user" varchar(64),
	"log_cwd" varchar(256),
	"log_permissions"  char(3),
        "log_group_rights" char(3),
        "log_command" TEXT,
	PRIMARY KEY (log_xid, log_directory)
);

CREATE TABLE subscribers (
	"sub_id" VARCHAR(64),
	"sub_directory" varchar(256),
	"sub_inherit" smallint NOT NULL,
	"sub_lease_duration" timestamp,
	"sub_cur_xid" bigint,
	PRIMARY KEY (sub_id, sub_directory)
);

/* Replication: tables used as a slave */
CREATE TABLE mounts (
        "mnt_master" VARCHAR(64) NOT NULL,
        "mnt_directory" VARCHAR(256) PRIMARY KEY,
        "mnt_state" VARCHAR(16),
        "mnt_last_xid" bigint
);


 CREATE TABLE constraints (
  "table_id"   integer references masterindex("id") ON DELETE CASCADE,
  "name"       varchar(64),
  "type"       char(1),
  "column"     varchar(64),
  "constraint" varchar(1024),
  PRIMARY KEY ("table_id", "name")
);
