#
#
# $Id$
#
# Checks for gSOAP and defines
# GSOAP_PREFIX SOAPCPP2 WSDL2H GSOAP_INCLUDES GSOAP_LIBS
# Usage: AC_CHECK_GSOAP(min-version, [ACTION-IF_FOUND], [ACTION-IF-NOT-FOUDD])
#

AC_DEFUN([AC_CHECK_GSOAP],[

 dnl argument ?

 gsoap_path=$PATH

 AC_ARG_WITH(gsoap-location,
    [  --with-gsoap-location=<location of the gsoap installation>],
    [GSOAP_PREFIX=$withval]
 )

 AC_ARG_WITH(gsoap-includes,
    [  --with-gsoap-includes=<directory of stdsoap.h>],
    [GSOAP_INCLUDES=$withval]
 )

 dnl if GSOAP_PREFIX not set, try using default prefix
 if test [-z "$GSOAP_PREFIX"] ; then
   GSOAP_PREFIX=${prefix}
 fi

 if test [ "$GSOAP_PREFIX" != "NONE" ] ; then
   gsoap_path=${GSOAP_PREFIX}/bin:${gsoap_path}
 fi

 dnl make sure that soapcpp2 exists
 AC_PATH_PROG(SOAPCPP2, soapcpp2,, ${gsoap_path})
 if test [-z "$SOAPCPP2"] ; then
   AC_MSG_ERROR(gSOAP (soapcpp2) distribution not detected) ;
 fi
 
 dnl make sure that wsdl2h exists
 AC_PATH_PROG(WSDL2H, wsdl2h,, ${gsoap_path})
 if test [-z "$WSDL2H"] ; then
   AC_MSG_ERROR(gSOAP (wsdl2h) distribution not detected) ;
 fi

 gsoap_path=`dirname ${SOAPCPP2}`
# SOAPCPP2=${gsoap_path}/soapcpp2
# WSDL2H=${gsoap_path}/wsdl2h
 GSOAP_PREFIX=`dirname ${gsoap_path}`

if test x$GSOAP_INCLUDES != x ; then
 GSOAP_INCLUDES=${GSOAP_PREFIX}/include:${GSOAP_PREFIX}/import
fi

AC_MSG_NOTICE(["Found $SOAPCPP2"])

# dnl make sure the package version is close
 gsoap_version=`${SOAPCPP2} -v| grep -o "[[0-9]]\.[[0-9]][[.0-9a-z]]*"`
 gsoap_mayor_version=`echo $gsoap_version | cut -d'.' -f1`
 gsoap_minor_version=`echo $gsoap_version | cut -d'.' -f2`
 gsoap_sub_version=`echo $gsoap_version | cut -d'.' -f3`
 gsoap_min_version=$1
 gsoap_min_mayor_version=`echo $gsoap_min_version | cut -d'.' -f1`
 gsoap_min_minor_version=`echo $gsoap_min_version | cut -d'.' -f2`
 gsoap_min_sub_version=`echo $gsoap_min_version | cut -d'.' -f3`
 AC_MSG_NOTICE(["Found gSOAP version $gsoap_mayor_version.$gsoap_minor_version.$gsoap_sub_version, min version is $gsoap_min_mayor_version.$gsoap_min_minor_version.$gsoap_min_sub_version"])

 if test $gsoap_min_mayor_version -lt $gsoap_mayor_version;
   then [ $2 ];
   else if test $gsoap_min_mayor_version -eq $gsoap_mayor_version -a $gsoap_min_minor_version -lt $gsoap_minor_version;
     then [ $3 ];
     else [ $2 ];
   fi;
 fi;
 

 #dnl TODO: we need to check that the library is really there!!!
 GSOAP_LIBS="-L${GSOAP_PREFIX}/lib -lgsoapssl++"

 AC_MSG_NOTICE([Setting GSOAP_LIBS to $GSOAP_LIBS])

 GSOAP_CFLAGS=$GSOAP_INCLUDES
 
 AC_SUBST(GSOAP_PREFIX)
 AC_SUBST(SOAPCPP2)
 AC_SUBST(WSDL2H)
 AC_SUBST(GSOAP_INCLUDES)
 AC_SUBST(GSOAP_LIBS)
 AC_SUBST(GSOAP_CFLAGS)
]
)
