dnl Usage:
dnl AC_EDITLINE
dnl Adds editline to the include path or fails if it doesn't find it

AC_DEFUN([AC_EDITLINE],
[
  AC_ARG_WITH(
    editline-prefix,
    AC_HELP_STRING(
      [--with-editline-prefix=DIR],
      [root of the editline installation]
    ),
    [ac_editline_prefix=$withval],
    [ac_editline_prefix=""]
  )
  
  if test -z "$ac_editline_prefix" ; then
    AC_CHECK_HEADER([editline/readline.h],
                  [AC_DEFINE([HAVE_EDITLINE_READLINE_H],
                    [1], "Default editline/readline.h header found")],
                  [AC_MSG_ERROR(["Could not find editline/readline.h header file!"])])
    AC_CHECK_LIB(edit, readline, CLI_LIBS="$CLIENT_LIBS -ledit",
               AC_MSG_ERROR("No editline library found!"))

  else
    ac_save_cppflags=$CPPFLAGS
    ac_save_libs=$LIBS
    
    CPPFLAGS="$CPPFLAGS -I$ac_editline_prefix/include"
    LIBS="$LIBS -L$ac_editline_prefix/lib -ledit"

    AC_CHECK_HEADER([editline/readline.h],
                  [AC_DEFINE([HAVE_EDITLINE_READLINE_H],
                    [1], "editline/readline.h header found")],
                  [AC_MSG_ERROR(["Could not find editline/readline.h header file!"])])
    AC_CHECK_LIB(edit, readline, CLI_LIBS="$CLIENT_LIBS -L$ac_editline_prefix/lib -ledit",
               AC_MSG_ERROR("No editline library found!"))

    CPPFLAGS="$ac_save_cppflags -I$ac_editline_prefix/include"
#    LDFLAGS="$LDFLAGS -L$ac_editline_prefix/lib -ledit"
    LIBS=$ac_save_libs

  fi
])
 
