/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: ConfigContext.h,v 1.3 2010/04/14 07:15:30 asunil Exp $
//
#ifndef CONFIG_CONTEXT_H
#define CONFIG_CONTEXT_H

#include "ConfigParser.h"
#include "ConfigFileLine.h"

#undef yyFlexLexer
#define yyFlexLexer CFlexLexer

#ifndef __FLEX_LEXER_H
#include "FlexLexer.h"
#endif

#include <string>

struct LexerContext {
  std::string val;
  int lineNumber;
};


class ConfigLexer: public CFlexLexer
{
 public:
  ConfigFileLine *getVal() { return lval; };
  int yylex();
  void flush();
  int lineNumber() const {
    return extra.lineNumber;
  };
  int nextLine() {
    return extra.lineNumber++;
  };
 private:
  LexerContext extra;
  ConfigFileLine *lval;
};


struct ConfigContext {
  ConfigLexer lexer;
  ConfigParser *parser;
  std::string scope;
  int lastErrorLineNumber;
};

#endif // CONFIG_CONTEXT_H
