/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include "Constant.h"

#include <stdlib.h>
#include <ctype.h>

namespace QueryParser{

Constant::Constant(const std::string &c)
{
  constant=c;
}


Constant::~Constant()
{
  // Nothing to be done, here
}


int Constant::toSQL(const std::string &prefix, std::string &query, const std::string &style)
{
  query.append(constant);
  return constant.size();
}


void Constant::setConstant(const std::string &arg)
{
  constant=arg;
}


bool Constant::isInt() const
{
  if( !constant.size() )
    return false;

  for( size_t i = 0; i< constant.size(); i++) {
    if( !isdigit(constant[i]) )
      return false;
  }
  return true;
}


int Constant::toInt() const
{
  return atoi(constant.c_str());
}

}
