/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include "Elements.h"
#include <cstdio>

namespace QueryParser{

Elements::Elements(const std::string &id, int i, int j)
  : Identifier(id)
{
  lower=i;
  upper=j;
}


Elements::Elements(const Identifier &ident)
  : Identifier(ident)
{
  lower=0;
  upper=0;
}

Elements::~Elements()
{
  // Nothing to be done, here
}


int Elements::toSQL(const std::string &prefix, std::string &query, const std::string &style)
{
  int size=Identifier::toSQL(prefix, query, style);
  char buffer[51];
  if(lower != upper)
    size+=snprintf(buffer, 50, "[%d:%d]", lower, upper);
  else
    size+=snprintf(buffer, 50, "[%d]", lower);
    
  query.append(buffer);
  return size;
}


void Elements::setRange(int i, int j)
{
  lower=i;
  upper=j;
}

}
