/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include "GroupBy.h"
#include <stdlib.h>
#include <stdio.h>

namespace QueryParser{

GroupBy::GroupBy(Expression *e)
  : exp(e)
{

}


GroupBy::~GroupBy()
{
  delete exp;
}


int GroupBy::toSQL(const std::string &prefix, std::string &query,
		 const std::string &style)
{
  query += " GROUP BY (";
  exp->toSQL(prefix, query, style);
  query += ")";

  return 1;
}

void GroupBy::addToTableMap(TableMap &tableMap)
{
  exp->addToTableMap(tableMap);
}


void GroupBy::replaceTableNames(TableMap &tableMap)
{
  exp->replaceTableNames(tableMap);
}

}
