/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include <ctype.h>

#include "Identifier.h"
#include <stdio.h>

namespace QueryParser{

Identifier::Identifier(const std::string &id, bool s)
  : system(s)
{
  identifier=id;
}

Identifier::~Identifier()
{
  // Nothing to be done, here
}


int Identifier::toSQL(const std::string &prefix, std::string &query,
		      const std::string &style)
{
  if(system) {
    if(style.find("LFC")!=std::string::npos and identifier == "FILE") {
	query.append("name");
	return identifier.size();
    }
    std::string id=identifier;
    if( id == "ACL" )
      id = "ACLS";

    for(unsigned int i=0; i<id.size(); i++)
      id[i]=tolower(id[i]);
    query.append("\"").append(id).append("\"");
    return identifier.size();
  }
  if( prefix.size() )
    query.append("\"").append(prefix).append(identifier).append("\"");
  else
    query.append(identifier);
  return identifier.size();
}


void Identifier::setIdentifier(const std::string &id)
{
  identifier=id;
}


void Identifier::addIndex(int i)
{
  char buff[20];
  sprintf(buff, "[%d]", i);
  identifier.append(buff);
}


void Identifier::addRange(int i, int j)
{
  char buff[20];
  sprintf(buff, "[%d:%d]", i, j);
  identifier.append(buff);
}

}
