/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef QUERY_PARSER_JOIN_H
#define QUERY_PARSER_JOIN_H

#include "Constraint.h"

static const int JOIN_CROSS = 1;
static const int JOIN_CROSS_ON = 2;
static const int JOIN_LEFT_ON = 3;
static const int JOIN_LEFT_USING = 4;
static const int JOIN_RIGHT_ON = 5;
static const int JOIN_RIGHT_USING = 6;
static const int JOIN_INNER_ON = 7;
static const int JOIN_INNER_USING = 8;

namespace QueryParser {

  class Join: public Constraint {
  public:
    Join(int type, Expression *l, Expression *r, Expression *c=NULL);
    virtual ~Join();

    virtual int toSQL(const std::string &prefix, 
		      std::string &query, const std::string &style = "");
    
    virtual void addToTableMap(TableMap &tableMap);
    virtual void replaceTableNames(TableMap &tableMap);

  private:
    int joinType;
    Expression *left;
    Expression *right;
    Expression *on;
  };
}

#endif // QUERY_PARSER_JOIN_H
