/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef SCANNER_CONTEXT_H
#define SCANNER_CONTEXT_H

#include "Expression.h"
#include "Constraint.h"
#ifndef __FLEX_LEXER_H
#include "FlexLexer.h"
#endif

#include <list>

class QueryLexer: public yyFlexLexer
{
 public:
  QueryParser::Expression *getVal() { return lval; };
  int yylex();
  void flush();
 private:
  std::string extra;
  QueryParser::Expression *lval;
};

struct ScannerContext {
  QueryLexer lexer;
  QueryParser::Expression *rootExpression;
  std::list<QueryParser::Constraint *> constraints;
};

#endif // SCANNER_CONTEXT_H
