/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include <ctype.h>

#include "Table.h"
#include "Identifier.h"
// #include <iostream>

namespace QueryParser{

Table::Table(const std::string &name)
  : table(name), tableOptions(0)
{ 
  //   std::cout << "Creating table instance for " << table << "\n";
  if( table.size() && table[table.size()-1] == ':' ) // Remove trailing :
    table.resize(table.size()-1);
  //  std::cout << "Now we have " << table << "\n";
}

Table::~Table()
{
  // Nothing to be done, here
}


int Table::toSQL(const std::string &prefix, std::string &query,
		 const std::string &style)
{
  query.append(table);

  return table.size();
}


void Table::addToTableMap(TableMap &tableMap)
{
  //  std::cout << "Trying table " << table << "\n";
  if( tableMap.find(table) == tableMap.end() ) {
    tableMap[table] = TableEntry();
    //    std::cout << "Adding table " << table << "\n";
  }
}


void Table::replaceTableNames(TableMap &tableMap)
{
  tableOptions = tableMap[table].props.flags;
  //  std::cout << "About to replace " << table << "\n";
  table = tableMap[table].props.directoryTable;
  //  std::cout << "  with table " << table << "\n";
}

}
