/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef QUERY_PARSER_TABLE_COLUMN_H
#define QUERY_PARSER_TABLE_COLUMN_H

#include "Identifier.h"

namespace QueryParser {
  class Table;

  class TableColumn: public Expression {
  public:
    TableColumn(Identifier *ident, Table *t);
    TableColumn(Identifier *ident);
    ~TableColumn();

    virtual int toSQL(const std::string &prefix, std::string &query, const std::string &style = "");
    virtual bool isCompound() const { return false; };

    virtual void addToTableMap(TableMap &tableMap);
    virtual void replaceTableNames(TableMap &tableMap);

    int getOptions() const;

    void setTable(Table *id) { table = id; };

  private:
    Table *table;
    Identifier *id;
  };
}

#endif // QUERY_PARSER_TABLE_COLUMN_H
