/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: DBHelper.h,v 1.5 2010/04/14 07:15:30 asunil Exp $
//
#ifndef DB_HELPER_H
#define DB_HELPER_H

#include <string>

class DBHelper {
public:
  // SQL data type conversion
  virtual std::string mdToDBType(const std::string &type) const = 0;
  virtual std::string dbToMDType(const std::string &type) const = 0;
  virtual const char *backend() const = 0;
  
  // GUID encoding/decoding from DB type
  virtual std::string readGUID(const std::string &guid) const = 0;
  virtual std::string writeGUID(const std::string &guids) const = 0;
  virtual const char *guidType() const = 0;

  virtual ~DBHelper() {};
};

#endif // DB_HELPER_H
