/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include "MDBuffer.h"
#include <stdio.h>

MDBuffer::MDBuffer()
  : producerFinished(false), cancelled(false)
{
  buffer="";
}


MDBuffer::~MDBuffer()
{

}


bool MDBuffer::isProducerFinished() const
{
  return producerFinished;
}


bool MDBuffer::isCancelled() const
{
  return cancelled;
}

void MDBuffer::start() {
  buffer.clear();
  cancelled = false;
}

bool MDBuffer::isAsynchronous() const
{
  return false;
}


void MDBuffer::cancel()
{
  cancelled=true;
}


void MDBuffer::append(const std::string &text)
{
  buffer.append(text);
}


void MDBuffer::append(int value)
{
  char buff[21];
  snprintf(buff, 20, "%d", value);
  buffer.append(buff);
}

void MDBuffer::read(std::string &buf, int timeout)
{
  // Returns a copy of buffer and empties it
  buf="";
  buffer.swap(buf);
}


void MDBuffer::flush(std::string &result)
{
  result = "";
  buffer.swap(result);
}
