/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: MDFCMySQLServer.h,v 1.7 2010/04/14 07:15:30 asunil Exp $
//
#ifndef MDFCMYSQLSERVER_H
#define MDFCMYSQLSERVER_H

#include "MDLFCServer.h"

class MDFCMySQLServer: public MDLFCServer {
 public:
  MDFCMySQLServer(MDBuffer &outbuf);
  virtual ~MDFCMySQLServer();

  virtual void setAttr(const std::string &path, 
		       std::vector< std::string > &attributes,
		       std::vector< std::string > &values);

  virtual void clearAttr(const std::string &path,
			 const std::string &attribute);

private:

  virtual std::string createTable(const EntryProps &p,
				  AttrList &attrs,
				  Statement &statement);

  virtual bool alterTableColumns(const std::string &tableName,
				 const AttrList &attributes,
				 bool remove);

  void doBulkRead(Statement &statement, std::string &query,
		  size_t fields, bool &foundSomething);

  virtual int getAttributes(const std::string &table,
			    AttrList &keys,
			    bool all=false);

  virtual std::string updateAttrQuery(const EntryProps &p,
				      const std::string &entries,
				      bool isPattern,
				      std::vector< std::string > &attributes,
				      std::vector< std::string > &values,
				      const std::string &condition,
				      bool eval);

};

#endif // MDFCMYSQLSERVER_H
