/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: MDServerFactory.h,v 1.9 2010/04/14 07:15:30 asunil Exp $
//
#ifndef MDSERVER_FACTORY_H
#define MDSERVER_FACTORY_H

#include <iostream>
#include "util/DBUtil.h"

class MDBuffer;
class MDServer;
class DatabaseConnection;

class MDServerFactory {
public:
  /**
   * Wraps a MDServer object around an existing connection
   */
  static MDServer *mdServer(MDBuffer &outbuf, DatabaseConnection *connection = NULL) throw (SQLException);

private:
  static int checkTableExists(DatabaseConnection *connection,
			      const std::string &name,
			      const std::string &searchSchema,
			      std::string &detectedSchema);
  static bool debug;
};

#endif // MDSERVER_FACTORY_H
