/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


/** MDBuffer is a class which implements an asynchronous buffer which
    sits in between MDServer and the server program
**/

#ifndef MDSOCKETBUFFER_H
#define MDSOCKETBUFFER_H

#include "MDBuffer.h"
#include <string>

class TCPSocket;

class MDSocketBuffer : public MDBuffer {
 public:
  MDSocketBuffer(TCPSocket *socketInit);
  MDSocketBuffer();
  virtual ~MDSocketBuffer();

  virtual void append(const std::string &text);
  virtual void append(int value);

  virtual bool isProducerFinished() const;

  virtual void read(std::string &buf, int timeout = -1);

  virtual void flush(std::string &result);
  virtual void flush(); 
  
  void setSocket(TCPSocket *socket);
  TCPSocket *getSocket();
  
protected:
  TCPSocket *socket;
};

#endif
