/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef MDSQL_H
#define MDSQL_H

#include "MDServer.h"
#include "MDBuffer.h"
#include "debug.h"

#define yyFlexLexer sqlyyFlexLexer
#include "sqlparser/amga_sql.h"
int sqlyyparse(void* asp);


class MDSql: public MDServer {
public:
  MDSql(MDBuffer &outbuf);
  virtual ~MDSql();
  int sqlParse(std::string &line, int type, std::string &query);
  int sqlExec(std::string &line, int type);
  void handleOutput();
  void printSQLAttr();

  virtual void doBulkRead(Statement &statement, std::string &query,
                          size_t fields, bool &foundSomething) = 0;
  AmgaSqlParser* asp;
};


#endif

