/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: MySQLHelper.h,v 1.6 2010/04/14 07:15:30 asunil Exp $
//
#ifndef MYSQL_HELPER_H
#define MYSQL_HELPER_H

#include "DBHelper.h"
#include "util/DatabaseConnection.h"


class MySQLHelper: public DBHelper {
 public:
  // SQL data type conversion
  virtual std::string mdToDBType(const std::string &type) const;
  virtual std::string dbToMDType(const std::string &type) const;
  virtual const char *backend() const { return "MySQL"; };

  uint64_t sequenceNextValue(
    DatabaseConnection *dbConn, const std::string &sequence) 
    throw (SQLException);

  uint64_t sequenceCurrentValue(
    DatabaseConnection *dbConn, const std::string &sequence) 
    throw (SQLException);
  
  // GUID reading/writing
  virtual std::string readGUID(const std::string &guid) const;
  virtual std::string writeGUID(const std::string &guids) const;
  virtual const char *guidType() const { return "BINARY(16)"; };

};

#endif // MYSQL_HELPER_H
