/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "PgHelper.h"

std::string PgHelper::mdToDBType(const std::string &type) const
{
  std::string t;

  if(type == "int")
    return "integer";

  if(type == "float")
    return "double precision";

  if(type.substr(0, 7) == "varchar") {
    t = "character varying";
    t.append(type.substr(7));
    return t;
  }

  if(type.substr(0, 6) == "varbit") {
    t = "bit varying";
    t.append(type.substr(6));
    return t;
  }

  return type;
  return type;
}
 

std::string PgHelper::dbToMDType(const std::string &type) const
{
  std::string t;

  if (type == "double precision")
    return "float";

  if (type == "integer")
    return "int";

  if (type.substr(0, 17) == "character varying") {
    t = "varchar";
    t.append(type.substr(17));
    return t;
  }
  
  if (type.substr(0, 11) == "bit varying") {
    t = "varbit";
    t.append(type.substr(11));
    return t;
  }
  
  if (type == "timestamp without time zone")
    return "timestamp";

  // text is the same

  // numeric is the same

  return type;
}


std::string PgHelper::readGUID(const std::string &guid) const 
{
  return "encode(\"" + guid + "\", 'hex')";
}

std::string PgHelper::writeGUID(const std::string &guid) const
{
  if( guid != "?" )
    return "decode('" + guid + "', 'hex')";
  else
    return "decode(?, 'hex')";
}


// std::string MDFCOracleServer::multiTableUpdateSyntax(const std::list< std::string > &tables)
// {
//   std::string s;

//   for (std::list< std::string>::const_iterator I = tables.begin();
//        I != tables.end(); ) {
//     if( I == tables.begin() ) {
//       s += (*I) + " FROM ";
//       I++;
//     } else {
//       s += (*I);
//       I++;
//       if( I != tables.end() )
// 	s += ", ";
//     }
//   }

//   return s;
// }

