/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef USER_CONTEXT_H
#define USER_CONTEXT_H

#include <string>

struct UserContext {
  std::string login;                   // The login name
  std::string name;                    // The full user name
  std::string permissionMask;          // The users permission mask
  std::string groupMask;               // The group permission mask
  std::string currentDir;              // The current directory
                                       // (initially home-dir)
  std::string password;                // A password, if supplied

  std::string distinguishedName;       // Distinguished name if logging in via certificate

  enum Attributes { Login, Name, PermissionMask, GroupMask,
		    CurrentDir };
  static const int maxLoginSize;
  static const int maxNameSize;
  static const int maxPermissionSize;
  static const int maxGroupMaskSize;
  static const int maxPathSize;
};

#endif // USER_CONTEXT_H
