/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: sqlHelpers.h,v 1.4 2010/04/14 07:15:30 asunil Exp $
//
#ifndef SQL_HELPERS_H
#define SQL_HELPERS_H

#include <string>
#include <list>

extern int sqlPattern(const std::string &in, std::string &out);

extern std::string sqlType(int type, int size, int precision);

extern bool dirRegexpPattern(const std::string &in, std::string &out);

// Directory handling
extern bool dirLineIsBefore(const std::string &left, const std::string &right);
extern bool isSubdirOf(const std::string &left, const std::string &right);
extern int dirLevel(const std::string &dir);
extern int pathPieces(const std::string &path, std::list< std::string > &parts);
  
#endif // SQL_HELPERS_H
