/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef CORE_DATA_ACCESS_H
#define CORE_DATA_ACCESS_H

#include "MDSoapClient.h"

#define _NO_OPS 0
#define _SELECT 1
#define _INSERT 2
#define _DELETE 3
#define _UPDATE 4

typedef _wsdai__DestroyDataResourceRequest  DestroyDataResourceRequest;
typedef _wsdai__DestroyDataResourceResponse DestroyDataResourceResponse;

class CoreDataAccess: public MDSoapClient {
public:
  CoreDataAccess(const std::string &host="" , int port=8833, const std::string &path = "",
            const std::string &configFile = "", bool keep_alive=false, bool dbg=false);

  ~CoreDataAccess();

  int MakeDestroyDataResourceRequest(std::string &dran
                     , DestroyDataResourceRequest **req);
  int DestroyDataResource(DestroyDataResourceRequest *req);
  int SimpleExecuteDestroy(std::string &dran);

protected:

};

#endif
