/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef DBRESULT_H
#define DBRESULT_H

#include <string>
#include <vector>
#include <ostream>

class DBResult{
public:

	DBResult();
	virtual ~DBResult();

  // The error code.
  int errorCode;
  // The eror message, if one is present.
  std::string errorMsg;
  // The first line of the server response
  std::string serverResult;
};

std::ostream& operator<<(std::ostream& os, const DBResult &result);

#endif // DBRESULT_H
