/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "MDSoapBuffer.h"

#include <iostream>

static bool debug = false;
#include "debug.h"

#define DEFAULT_MAX_SIZE 16*1024*1024

using namespace std;

MDSoapBuffer::MDSoapBuffer() 
  : maxSize(DEFAULT_MAX_SIZE), overFlow(false)
{ }

MDSoapBuffer::~MDSoapBuffer()
{ }

void MDSoapBuffer::start()
{
  buffer.clear();
  cancelled = false;
  overFlow = false;
}

bool MDSoapBuffer::isOverFlow() {
  return overFlow ;
} 

void MDSoapBuffer::setDebug(bool _debug)
{
  debug = _debug;
}

void MDSoapBuffer::append(const std::string &text)
{
  // DMESG("MDSoapBuffer [append] " << text << endl);
  if ( buffer.size() > maxSize ) {
    overFlow = true;
    return;
  }
  buffer.append(text);
}

void MDSoapBuffer::finish()
{
  // DMESG("MDSoapBuffer [finish]" << endl);
  cancelled = false;
}

