/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef SQL_ACCESS_FACTORY_H
#define SQL_ACCESS_FACTORY_H

#include "MDSoapClient.h"

#define _NO_OPS 0
#define _SELECT 1
#define _INSERT 2
#define _DELETE 3
#define _UPDATE 4

typedef _wsdair__SQLExecuteFactoryRequest  SQLExecuteFactoryRequest;
typedef wsdai__DataResourceAddressListType SQLExecuteFactoryResponse;
typedef wsdai__DataResourceAddressType EndpointReference;


class SQLAccessFactory: public MDSoapClient {
public:
  SQLAccessFactory(const std::string &host="" , int port=8833, const std::string &path = "",
            const std::string &configFile = "", bool keep_alive=false, bool dbg=false);

  ~SQLAccessFactory();

  int SQLExecuteFactory(SQLExecuteFactoryRequest *req,
                 SQLExecuteFactoryResponse **res);

  int MakeSQLExecuteFactoryRequest(std::string &dran
                     , std::string &command
                     , SQLExecuteFactoryRequest **req);

  int FetchEndpointReference(SQLExecuteFactoryResponse *seRes
                      , EndpointReference** er);

  void PrintEndpointReference(EndpointReference* er, std::string & result);

  int SimpleExecute(std::string dran, std::string command, std::string & result);

protected:

};

#endif

