/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef SQL_ROWSET_H
#define SQL_ROWSET_H

#include "SQLAccess.h"

typedef _wsdair__GetTuplesRequest GetTuplesRequest; 
typedef  _wsdair__GetTuplesResponse GetTuplesResponse;
typedef _wsdai__GetDataResourcePropertyDocumentRequest GetSQLRowsetPropertyDocumentRequest ;
typedef wsdair__SQLRowsetPropertyDocumentType  GetSQLRowsetPropertyDocumentResponse;
typedef wsdai__PropertyDocumentType PropertyDocument;


class SQLRowset: public SQLAccess {
public:

  ~SQLRowset();

  SQLRowset(const std::string &host , int port, std::string &path,
            const std::string &configFile, bool keep_alive=false, bool dbg=false) ;

  int GetTuples(GetTuplesRequest *req,
                GetTuplesResponse **res) ;

  int FetchWRS(GetTuplesResponse *seRes
                      , WebRowSet** wrs) ;

  int GetUpdateCount( SQLExecuteResponse *seRes
                             , int& updateCount);

  int MakeGetTuplesRequest(std::string &dran
                     , std::string &uri
                     , int position
                     , int count
                     , GetTuplesRequest **req) ;


  int SimpleExecuteRowset(std::string dran
            , int position
            , int count
            , const std::string uri = "");

  int GetSQLRowsetPropertyDocument(
      GetSQLRowsetPropertyDocumentRequest *req,
      GetSQLRowsetPropertyDocumentResponse **res);

  int MakeGetSQLRowsetPropertyDocumentRequest(std::string &dran
                     , GetSQLRowsetPropertyDocumentRequest **req);

  void PrintSQLRowsetPropertyDocument(
           GetSQLRowsetPropertyDocumentResponse* res);


  int SimpleRowsetPropertyDocument(std::string &dran);

};

#endif 
