/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef S_SQL_ACCESS_H
#define S_SQL_ACCESS_H

#include <iostream>

#include "WSDairH.h"
#include "server/MDInterpreter.h"
#include "DBResult.h"
#include "WSDAIRUtil.h"

/*************************************************************************
  The S_SQLAccess class manages SQLAccess messages at the SOAP server.
  
  CoreDataAccess::GenricQuery also uses this class to process query. 
*************************************************************************/

class S_SQLAccess {
public:
  void init(struct soap* soap, AutoDBConnection *helper
          , std::string &dran, std::string &query, bool _debug) ;

  /* response for SQLAccess::SQLExecute */
  int makeResponse( _wsdair__SQLExecuteResponse* res);

  /* response for CoreDataAccess::GenericQuery */
  int makeResponse( _wsdai__GenericQueryResponse* res );

  int handleQuery() ;

  void makePropertyDocument( wsdai__PropertyDocumentType* doc, bool ttt, std::string& dran);
  void makePropertyDocument( wsdair__SQLPropertyDocumentType* doc, std::string& dran );

private:
  struct soap* soap;
  std::string dran;
  std::string query;
  DBResult dbResult;
  std::vector<std::string> results;
  int colNum ;
  int rowsNo ;
  bool overFlow;
  MDInterpreter::CommandToken cmdToken ;
  AutoDBConnection* helper;
} ;


#endif
