/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef S_SQL_ACCESS_FACTORY_H
#define S_SQL_ACCESS_FACTORY_H

#include <iostream>

#include "WSDairH.h"
#include "WSDAIRUtil.h"

class S_SQLAccessFactory {
public:
  void init(struct soap* soap, AutoDBConnection *helper, 
            std::string &dran, std::string &query, bool _debug) ;

  int commitDirectoryToIndex2(EntryProps &prop,
         const std::string &indexTable, std::string &table, Statement &statement);
  int checkTooManyIndirectServiceForUser();

  int handleQuery();
  void makeResponse(wsdai__DataResourceAddressListType* res);
private:
  struct soap* soap;
  std::string dran;
  std::string query;
  AutoDBConnection* helper;
} ;

#endif
