/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef S_SQL_RESPONSE_H
#define S_SQL_RESPONSE_H

#include "WSDairH.h"
#include "WSDAIRUtil.h"

#define OP_ITEM 1
#define OP_UPDATE 2
#define OP_ROWSET 3
#define OP_TUPLE 4

class S_SQLResponse {
public:
  void init(struct soap *soap , AutoDBConnection* helper
          , unsigned int position, unsigned int* reqCount 
          , std::string& dran, wsdai__DatasetType* Dataset 
          , int opType, bool _debug) ;
  int handleRequest( std::string &table, int count
                   , int &num_column_row, DBResult &dbResult
                   , std::vector<std::string> &results);
  int parseDran(std::string &table, char &type, int &num_column_or_row, int rowset_type = 0);
  bool isUpdate();
  int makeResponse(int colNum , std::vector<std::string> &results);
  int makePropertyDocument(bool update, wsdair__SQLResponsePropertyDocumentType* doc);
  int processITEM();
  int DestroyDataResource(std::string &table, char type);
  int ValidDran();


  std::string dran;

protected:
  struct soap *soap;
  unsigned int position;
  unsigned int* reqCount;
  wsdai__DatasetType* Dataset;
  int opType;
  bool overFlow;
  AutoDBConnection* helper;
};

class S_SQLResponseFactory: public S_SQLResponse {
public:
  void makeResponse(wsdai__DataResourceAddressListType* res);
};

#endif

