/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include "client/MDClient.h"
#include <stdlib.h>
#include <unistd.h>

#include <iostream>
#include <sstream>
#include <fstream>
#include <exception>



int main (int argc, char *argv[])
{
  int res;
  std::string command;
  std::string comm;

  if(argc < 2)
  {
    std::cout << "usage: sqltest input_sql_file " << std::endl;
    return 0;
  }

  std::ifstream iF(argv[1]);
  iF.exceptions (std::ios_base::badbit);

  if (! iF.is_open() ) {
    std::cerr << "Error opening file" << std::endl;
    exit(-1);
  }

  MDClient client;
  if(client.connectToServer()){
     std::cerr << client.getError() << std::endl;
     exit(-1);
  }


  while ( !iF.eof() ) {
    getline(iF, command);

    if( command.size() == 0 ) break ;
    if( command[0] == '#' ) {
        std::cout <<  "====================================================\n"; 
        std::cout << " INFO : " << command << "\n"; 
        std::cout <<  "====================================================\n"; 
    	continue ;
    }

/*
    comm = "transaction" ;
    if( ( res=client.execute(comm)) ){
        std::cout << "  ERROR: execute failed"
                  << "   (" << res << "): "
                  << client.getError() << std::endl;
        return res;
    }
*/


    std::cout << "INPUT : " << command << "\n"; 

    if( ( res=client.execute(command)) ){
        std::cout << "  ERROR: execute failed"
                  << "   (" << res << "): "
                  << client.getError() << std::endl;
	return -1;
    } else {
      while(!client.eot()) {
        std::string row;
        if(res=client.fetchRow(row)){
         std::cout << "Error fetching: " << res << std::endl;
            return -1;
        }
        std::cout << row << std::endl;
      }
    }

/*
    comm = "commit" ;
    if( ( res=client.execute(comm)) ){
        std::cout << "  ERROR: execute failed"
                  << "   (" << res << "): "
                  << client.getError() << std::endl;
        return res;
    }
*/


  }
   
  client.disconnect();

  return 0;
}

