/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef _CLOCK_H_
#define _CLOCK_H_

#include <string>
#include <sys/times.h>

class Clock
{
public:
  enum State {Stopped, Running};
  
  Clock();
  virtual ~Clock();
  void start();
  void stop();
  void resume();
  void reset(); 
  std::string print(const std::string &msg);
  double getRealTime();
  
 private:
  static double CLK_SEC;
  void checkIsInState(State allowedState);
  
  State state;
  
  clock_t st_time;
  struct tms st_cpu;
  
  clock_t acc_time;  
  struct tms acc_cpu;
};

#endif //_CLOCK_H_
