/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef DBUTIL_H_
#define DBUTIL_H_

#include <exception>
#include <string>

class Statement;

class SQLException : public std::exception {
public:
  SQLException(const std::string &message) throw ();
  SQLException(Statement &statement) throw ();
  SQLException(const std::string &message, Statement &statement) throw ();
  
  virtual ~SQLException() throw () {};
  const char *what() const throw();

private:
  // Exception message
  std::string userMessage;  
};


class StatementWrapper
{
public:
	StatementWrapper(Statement &statement);
	virtual ~StatementWrapper();
    
    void exec(const std::string &query) throw (SQLException);
    
private:
    Statement& _statement;
};

#endif /*DBUTIL_H_*/
