/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#ifndef SOCKETUTIL_H_
#define SOCKETUTIL_H_

#include <stdexcept>
#include <string>

void throwException(const std::string& msg) 
    throw (std::runtime_error);
    
void write(int socket, const std::string& text) 
    throw (std::runtime_error);
    
void readLine(int socket, std::string &line, std::string &buffer) 
    throw (std::runtime_error);



#endif /*SOCKETUTIL_H_*/
