/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


// -*- Mode:c++ -*-
//
// $Id: guidHelper.h,v 1.4 2010/04/14 07:15:30 asunil Exp $
//
#ifndef GUID_HELPER_H
#define GUID_HELPER_H

#include <string>
#include <stdexcept>

#include "uuid/uuid.h"

namespace AMGA {
  std::string validateGUID(const std::string &guid)
    throw (std::runtime_error);

  void GUIDtoRaw(const std::string &guid, unsigned char buffer[16])
    throw (std::runtime_error);

  std::string hexifyGUID(uuid_t uuid)
    throw (std::runtime_error);

  std::string niceGUID(const std::string &guid)
    throw (std::runtime_error);

  std::string normalizeMAC(const std::string &mac)
    throw (std::runtime_error);
}

#endif
