/*
  Copyright (c) Members of the EGEE Collaboration. 2004.
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

//
// C++ Implementation: %{MODULE}
//
// Description:
//
//
// Author: %{AUTHOR} <%{EMAIL}>, (C) %{YEAR}
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "latch.h"

#include <zthread/Guard.h>

using namespace ZThread;

Latch::Latch()
: _c(_mtx), _latchOpen(false)
{
}


Latch::~Latch()
{
}


void Latch::signal() {
	Guard<Mutex> g(_mtx);
	_latchOpen = true;
	_c.broadcast();
}

void Latch::wait() {
	Guard<Mutex> g(_mtx);
	while (!_latchOpen) {
		_c.wait();
	}
}
