#!/bin/bash

error=0

port1=7733
port2=7744
port3=7722

# initialize data 
../md-test -p $port1 -c fed-init1.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port2 -c fed-init2.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1


# test federation feature
../md-test -p $port3 -c fed-test-1.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port3 -c fed-test-2.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port3 -c fed-test-2a.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port3 -c fed-test-2b.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port3 -c fed-test-2c.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port3 -c fed-test-2d.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port3 -c fed-test-3.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1


# clean data 
../md-test -p $port2 -c fed-clean2.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

../md-test -p $port1 -c fed-clean1.cfg
RETVAL=$?
[ $RETVAL -ne 0 ] && error=1

echo
echo ===============================================================
echo
[ $error -ne 0 ] && echo -e "\\033[1;31m There has been errors. Please Check !!!!!!"
[ $error -eq 0 ] && echo -e "\\033[1;32m All the Tests have been completed Successfully"
echo -e "\\033[0;39m"
echo ===============================================================

