/*
  Copyright (c) Members of the EGEE Collaboration. 2004. 
  See http://www.eu-egee.org/partners/ for details on the copyright
  holders.  

  Licensed under the Apache License, Version 2.0 (the "License"); 
  you may not use this file except in compliance with the License. 
  You may obtain a copy of the License at 

    http://www.apache.org/licenses/LICENSE-2.0 

  Unless required by applicable law or agreed to in writing, software 
  distributed under the License is distributed on an "AS IS" BASIS, 
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
  See the License for the specific language governing permissions and 
  limitations under the License.
*/


#include <iostream>
#include "ScannerContext.h"
#include <sstream>

extern int yyparse(void *);
extern int yydebug;

int main (int argc, char *argv[])
{
//  std::string testString("/roottree:MINPRODUCTION <= 449 and /roottree:MAXPRODUCTION >= 449");
//    std::string testString("=\"b1\"");
std::string testString("a > -1 and a - b > 10 and a = NULL");
//  char testString[500]="gen = \"bla:";
//  char testString[500]="range[2]";
//  char testString[500]="mytable:myColumn";
//  char testString[500]="sin + f * g";
  ScannerContext scanner;

  std::istringstream in(testString);
  scanner.lexer.switch_streams(&in, NULL);
  scanner.lexer.set_debug(1);
  yydebug = 1;

  if(yyparse(&scanner)>0) {
    std::cerr << "Error parsing!" << std::endl;
    exit(0);
  }

  std::string query;
  scanner.rootExpression->toSQL("user:", query);
  std::cout << "Parsing :>" << testString << "<  gives >" 
	    << query << "<" << std::endl;

  delete scanner.rootExpression;

  return 0;
}
